#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bmsg.h"
#include "fullempty_client.h"

#include "config.h"
#include "scan_client.h"

int main(int argc, char **argv)
{
  struct connection_t **c;
  int t, i;
  int a[3];
  int single_len, last_t, last_len;

  if (!(argc & 1)) {
    printf("odd number of arguments\n");
    abort();
  }

  t = (argc - 1) / 2;

  if ((t - 1) & t) {
    printf("thread count %d is not a power of two\n", t);
    abort();
  }

  setup();

  single_len = n / t;

  /* Last server waiting_gets leftovers if the array doesn't divide evenly: */
  last_t = t - 1;
  last_len = n - ((t - 1) * single_len);

  c = (struct connection_t **)malloc(t * sizeof(struct connection_t *));

  /* Connect to all servers: */
  for (i = 0; i < t; i++)
    c[i] = make_connection(argv[(i * 2) + 1], argv[(i * 2) + 2]);

  /* send data */
  for (i = 0; i < t; i++) {
    int len = ((i == last_t) ? last_len : single_len);
    a[0] = i;
    a[1] = t;
    a[2] = len;
    send_byte_message(c[i], 3 * sizeof(int), a);
    send_byte_message(c[i], len * sizeof(data_t), array + (i * single_len));
  }

  /* wait until we get results in fullempty vars 0 through t-1: */
  fullempty_loop(t, c, 0, t);

  /* tell all servers that we're done */
  for (i = 0; i < t; i++)
    send_byte_message(c[i], 4, "done");

  for (i = 0; i < t; i++) {
    int len = ((i == last_t) ? last_len : single_len);
    fullempty_get(i, len * sizeof(result_t), &(result[i * single_len]));
  }

  print_result();

  return 0;
}

